package com.devcom.acegi.http;

import org.apache.commons.httpclient.Credentials;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.InitializingBean;

public class HttpClientFactoryBean implements FactoryBean,InitializingBean {

	private HttpClient httpClient;
	private String username;
	private String password;
	private String authenticationHost;
	private String authenticationRealm;
	
	public Object getObject() throws Exception {
		return httpClient;
	}	
	public Class getObjectType() {
		return HttpClient.class;
	}
	public boolean isSingleton() {
		return true;
	}
	public void afterPropertiesSet() throws Exception {
		if ((username==null) || (password==null)) {
			throw new IllegalArgumentException("Vous devez dfinir le username et le password");
		}
		httpClient = new HttpClient();
		httpClient.getState().setAuthenticationPreemptive(true);
		Credentials credentials = new UsernamePasswordCredentials(username,password);
		httpClient.getState().setCredentials(authenticationRealm,authenticationHost,credentials);
	}
	public String getAuthenticationHost() {
		return authenticationHost;
	}
	public void setAuthenticationHost(String authenticationHost) {
		this.authenticationHost = authenticationHost;
	}
	public String getAuthenticationRealm() {
		return authenticationRealm;
	}
	public void setAuthenticationRealm(String authenticationRealm) {
		this.authenticationRealm = authenticationRealm;
	}
	public HttpClient getHttpClient() {
		return httpClient;
	}
	public void setHttpClient(HttpClient httpClient) {
		this.httpClient = httpClient;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}

}
